/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#ifndef IAO_COMM_H
#define IAO_COMM_H

void iao_logmsg(char *msg);
void iao_logsysmsg(char *msg);

#define ERR_COMM_OKAY			 0
#define ERR_COMM_RESOURCE 		-1
#define ERR_COMM_HOSTNAME 		-2
#define ERR_COMM_NO_CONNECTION	-3
#define ERR_COMM_REFUSED		-4
#define ERR_COMM_TIMEOUT 		-5
#define ERR_COMM_DISCONNECTED 	-6
#define ERR_SSL_FAILED			-7
#define ERR_COMM_PORTINUSE      -8

typedef struct 
{
	int fd;
	char myhost[1024];
	char myip[20];
	char remotehost[1024];
	char remoteip[1024];
	int remoteport;
    	int myport;
	int err;
#ifdef IAO_SSL
	void *ssl;
#endif
	long udp;
} iao_connection;

int iao_tcpinit(void);
char *iao_comm_errstr(iao_connection *connection);

long iao_gethostbyname(char *host, char *ip);
int iao_connect(char *host, int port, iao_connection *result);
int iao_server(int port, iao_connection *result);
int iao_accept(iao_connection *server, iao_connection *client, int milisec);

int iao_udp(iao_connection *udp, int myport, char *host, int port);


#ifdef IAO_SSL
int iao_sslconnect(char *host, int port, iao_connection *result, int milisec);
int iao_sslify(iao_connection *result, int milisec);
#endif
int iao_send(iao_connection *s, char *buff, int len, int milisec);
int iao_recv(iao_connection *s, char *buff, int len, int milisec);
void iao_bridge(iao_connection *c1, iao_connection *c2, int millisec);
void iao_close(iao_connection *s);

#endif
