/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#ifndef IAO_HTTP_H
#define IAO_HTTP_H

#include "iao_comm.h"

struct iao_http_channel_struct
{
	iao_connection connection;
	int statuscode;
	char status[512];
	char contenttype[50];
	char realhost[512]; /* In case of proxy */
	int realport; /* In case of proxy */
	char proxycridentials[512]; /* In case of proxy */
};
typedef struct iao_http_channel_struct iao_http_channel;

int iao_geturl(iao_http_channel *channel, char *url, char **data);
int iao_geturlproxy(iao_http_channel *channel, char *url, char **data,
    char *proxyhost, int proxyport, char *proxycridentials);


int iao_http_open(char *host, int port, int secure, iao_http_channel *channel);
int iao_http_proxy_open(char *host, int port, int secure, char *proxyhost,
          int proxyport, char *proxycridetials, iao_http_channel *channel);
int iao_http_get(iao_http_channel* channel, char *url);
int iao_http_post(iao_http_channel* channel, char *url, char *data, int len);
int iao_http_getpage(iao_http_channel* channel, char **buff);
void iao_http_close(iao_http_channel* channel);
char *iao_http_status(int code);




#endif
